-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.AddCleave = function(spell,threshold,spellid2,cast_id)
	if not cfg.spells[spell] then return end
	cfg.Cleave=cfg.Cleave or {}
	cfg.Cleave[spell]=cfg.Cleave[spell] or {}
	--cfg.Cleave[spell].enable=cfg.Cleave[spell].enable or start_state or "off"
	cfg.Cleave[spell].threshold=threshold or cfg.cleave_threshold
	cfg.cleave_threshold=cfg.Cleave[spell].threshold
	--cast_id=cast_id or cfg.spells[spell].id
	cfg.Cleave[spell].id=cast_id or cfg.spells[spell].id
	cfg.Cleave[spell].id2=spellid2 or cfg.Cleave[spell].id
	cfg.Cleave[spell].cast_time=0
	cfg.Cleave[spell].hit_time=0
	cfg.Cleave[spell].num=0
	cfg.Cleave[spell].targets={}
	cfg.Id2Cleave[cfg.Cleave[spell].id]=spell
	cfg.Id2Cleave[cfg.Cleave[spell].id2]=spell
end

lib.ResetCleave=function(cleaveID,timeStamp)
	--print(type(cleaveID))
	if cfg.Cleave then
		if type(cleaveID)=="number" then
			cleaveID=cfg.Id2Cleave[cleaveID] or "none"
		end
		if cfg.Cleave[cleaveID] then
			--print("Reseting Cleave "..cleaveID)
			timeStamp = timeStamp or time()
			if cfg.Cleave[cleaveID].cast_time<timeStamp then
				cfg.Cleave[cleaveID].cast_time = timeStamp
				if cfg.Cleave[cleaveID].cast_time>cfg.Cleave[cleaveID].hit_time then
					cfg.Cleave[cleaveID].targets={}
					cfg.Cleave[cleaveID].num=0
					if cfg.Cleave[cleaveID].text then cfg.Cleave[cleaveID].text:SetText("") end
					--lib.UpdateCleave(0)
				end
			end
		end	
	end
end

lib.AddCleaveTarget = function(cleaveID,destGUID,timeStamp)
	--print(cleaveID.." "..destGUID.." "..timeStamp)
	if cfg.Cleave then
		if type(cleaveID)=="number" then
			cfg.cleave_last=cfg.Id2Cleave[cleaveID] or "none"
		else
			cfg.cleave_last=cleaveID
		end
		if cfg.Cleave[cfg.cleave_last] then
			timeStamp = timeStamp or time()
			if not cfg.Cleave[cfg.cleave_last].targets[destGUID] then
				cfg.Cleave[cfg.cleave_last].targets[destGUID]=lib.AddNPC(destGUID)
				cfg.Cleave[cfg.cleave_last].num = cfg.Cleave[cfg.cleave_last].num + 1
				if cfg.Cleave[cfg.cleave_last].text then cfg.Cleave[cfg.cleave_last].text:SetText(cfg.Cleave[cfg.cleave_last].num>0 and cfg.Cleave[cfg.cleave_last].num or "") end
				lib.UpdateCleave(cfg.Cleave[cfg.cleave_last].num)
			end
		end	
	end
end

lib.UpdateCleave=function(targets)
	if cfg.cleave_targets~=targets then
		cfg.cleave_targets=targets
		if cfg.cleave_targets>1 then
			Heddmain.spells.cleave:SetText(cfg.cleave_targets)
			if cfg.cleave_targets>=cfg.cleave_threshold then
				Heddmain.spells.cleave:SetTextColor(1,0,0,1)
			else
				Heddmain.spells.cleave:SetTextColor(1,1,1,1)
			end
		else
			Heddmain.spells.cleave:SetText("")
		end
		cfg.Update=true
	end
end